from jnpr.junos import Device
from jnpr.junos.utils.config import Config
from jnpr.junos.op.configuration import RoutingInstancesTable
from jnpr.junos.op.interface_description import LogicalInterfaceDescriptionTable
from jnpr.junos.op.ethport import EthPortTable
from jnpr.junos.exception import *
from jnpr.junos.factory import loadyaml
from pprint import pprint as pprint

Device.auto_probe = 3
dev = Device("192.168.180.145", user='netbot',password='fd38*M0i')
print "--------------------------"
print "Connecting to Kilcarbery"
dev.open()
print 'Kilcarbery connected'
routing_instances_table = RoutingInstancesTable(dev).get().items()
vpls_instances = [instance for instance in routing_instances_table if instance[1][1][1]=='vpls']

nni_list = [instance for instance in vpls_instances]

print "Please choose the NNI form the following list:"
for i in range(len(nni_list)):
    print str(i+1)+")", nni_list[i][0]  

check_nni = False
while not check_nni:
    try:
        nni = input("Type a valid number to choose the NNI: ")
        if nni in range(1, len(nni_list)+1):
            check_nni = True
            nni-=1
    except:
        pass

nni_name = nni_list[nni][0]

print "--------------------------"    
print nni_name, "selected"
print "--------------------------" 

check_vlan =  False
while not check_vlan:
    try:
        vlan_id = input("Type a valid vlan-id 1~4093: ")
        if vlan_id in range(1,4094):
            check_vlan = True
            vlan_id = str(vlan_id)
    except:
        pass

print "--------------------------"    
print "Vlan", vlan_id ,"selected"
print "--------------------------"

main = '192.168.180.'+ nni_list[nni][1][2][1].split('.')[3]
backup = '192.168.180.'+nni_list[nni][1][3][1].split('.')[3]
cmd = 'set interfaces '+nni_list[nni][1][0][1]+' vlan-id-list '+vlan_id
vpls_id = nni_list[nni][1][4][1]
ae_cmd = 'set interfaces ae2.'+vpls_id+' vlan-id-list '+vlan_id

print cmd
#with Config(dev, mode='private') as cfg:  
#    cfg.load(cmd, format='set')
#    print cfg.diff()
#    cfg.commit(comment="Added vlan "+vlan_id+" on "+nni_name)
print 'All good!'
dev.close()
print 'Connection closed'

################################################################################
print "--------------------------"
print "Connecting to first ACX",main
try:
    dev_main = Device(main, user='netbot',password='fd38*M0i')
    dev_main.open()
    print main,"Connected"
    logical_units = EthPortTable(dev_main).get().keys()
    for u in logical_units:
        if "ae" in u and "."+vpls_id in u:
            ae_cmd = 'set interfaces '+u+' vlan-id-list '+vlan_id
            break
    print ae_cmd
#    with Config(dev_main, mode='private') as cfg_main:  
#        cfg_main.load(ae_cmd, format='set')
#        print cfg_main.diff()
#        cfg_main.commit(comment="Added vlan "+vlan_id+" on "+nni_name)
    print "All good!"
    dev_main.close()
    print "Connection closed"
except Exception as err:
    print err.args
    print "First ACX, config failed, please review config manually."

################################################################################
print "--------------------------"
print "Connecting to second ACX", backup
try:
    dev_backup = Device(backup, user='netbot',password='fd38*M0i')
    dev_backup.open()
    print backup,"Connected"
    logical_units = EthPortTable(dev_backup).get().keys()
    for u in logical_units:
        if "ae" in u and "."+vpls_id in u:
            ae_cmd = 'set interfaces '+u+' vlan-id-list '+vlan_id
            break
    print ae_cmd
    
#    with Config(dev_backup, mode='private') as cfg_backup:  
#        cfg_backup.load(ae_cmd, format='set')
#        print cfg_backup.diff()
#        cfg_backup.commit(comment="Added vlan "+vlan_id+" on "+nni_name)
    print "All Good"
    dev_backup.close()
    print "Connection closed"`1
    print err.args
    print "Second ACX, config failed, please review config manually."

print "--------------------------"
print "Done"